/********************************************************************************
 *                                                                              *
 *                                                                  *
 *                           CANDLE ON THE WIND                                 *
 *                                                                              *
 *  - attiny13,  RC- 9,6 , CKDIV8       *
 *    BODLEVEL   1,8                         *
 *                                                                              *
 * WinAVR 20080610,  -Os [ 27,9%  ]            *
 *                                                                              *
 * 18.12.2008 ARV Research  All rights reserved                                *
 *                                                                              *
 ********************************************************************************/
#include "e_candle.h"

///    "".
volatile tcandle candles[MAXCANDLES];

/**       .
 *    ,   LOW
*/
uint8_t rnd(void){
   uint8_t t;
   //      , 
   do t = random();
   //     LOW
   while (t<= LOW);           
   //      
   return t; 
}

/**     .
 *    .
*/
ISR(TIM0_OVF_vect){
    static uint8_t CNT = 0;     //  
    uint8_t output = 0,         //   
            mask = 1;           //  

    //   ""
    for(uint8_t i = 0; i < MAXCANDLES; i++){
        //       :
        //      ,
        if(candles[i].bright > CNT)
            output |= mask;     //      1
        //      
        mask <<= 1;
    }

    //      
    PORTB = output; 
    //   
    CNT++;
}

int main(void) {
	///     .
    ///      ()
    ///    .
    ///    3 (2 )  
    ///    20-30 ,    .
    DDRB = 255; 

    //    
    TCCR0B = _BV(CS00);
    //     
    TIMSK0 = _BV(TOIE0);
    //     
    sei();

    //   
	while(1){
        //    ""  
        for(uint8_t i=0; i<MAXCANDLES; i++){
            //    ""   .
            if(candles[i].period-- < 0){
                //   ,
                //       ""
                candles[i].bright = rnd();
                candles[i].period = random();
            }
        }
        //   
        _delay_us(STEP);
    }
}

