#include <avr/io.h>
#include <stdlib.h>
#include <avr/interrupt.h>
#include <util/delay.h>

///  LOW    .
///   ,    "" .
#define LOW     100
///  STEP     "" .
///  ,   ""     .
#define STEP    300
///  MAXCANDLES    "".
///   6, ..    .
#define MAXCANDLES 6

/// ,   "".
typedef struct {
    uint8_t bright;     ///  (..  )
    int8_t period;      ///   
} tcandle;

